=begin
(c) TIG 2009
material-delete.rb adds a new Method the Sketchup's Material Class- 
"material.delete" - it simply deletes that material from the model and
entities that used it get the default material instead...
v1.1 defn mining simplified and respond_to? material tested.
v1.2 mats made into array to remove [self].
v1.3 empty temp groups used without detriment.
v1.4 operation removed as it should be used inside another anyway.
=end
require 'sketchup.rb'
class Sketchup::Material
  def delete()
    model=Sketchup.active_model
    ents=model.entities; defs=model.definitions; mats=model.materials
    ents.each{|e|e.material=nil if e.respond_to?(:material)and e.material==self
      e.back_material=nil if e.kind_of?(Sketchup::Face)and e.back_material==self}
    defs.each{|d|d.entities.each{|e|e.material=nil if e.respond_to?(:material)and e.material==self
      e.back_material=nil if e.kind_of?(Sketchup::Face)and e.back_material==self}}
    group=ents.add_group();gents=group.entities ### temporarily use other materials
    temp=gents.add_group()
    (mats.to_a-[self]).each{|m|tc=temp.copy;tc.material=m}
    mats.current=nil if mats.current==self ### ensure self is not current material
    mats.purge_unused ### purge self from browser
    group.erase! ### erase! the temporary material user, use set as was.
  end#def
end#class
